# coding: utf-8

"""
    Camunda Platform REST API

    OpenApi Spec for Camunda Platform REST API.  # noqa: E501

    The version of the OpenAPI document: 7.16.0
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from generic_camunda_client.configuration import Configuration


class CalledProcessDefinitionDtoAllOf(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'called_from_activity_ids': 'list[str]',
        'calling_process_definition_id': 'str'
    }

    attribute_map = {
        'called_from_activity_ids': 'calledFromActivityIds',
        'calling_process_definition_id': 'callingProcessDefinitionId'
    }

    def __init__(self, called_from_activity_ids=None, calling_process_definition_id=None, local_vars_configuration=None):  # noqa: E501
        """CalledProcessDefinitionDtoAllOf - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._called_from_activity_ids = None
        self._calling_process_definition_id = None
        self.discriminator = None

        self.called_from_activity_ids = called_from_activity_ids
        self.calling_process_definition_id = calling_process_definition_id

    @property
    def called_from_activity_ids(self):
        """Gets the called_from_activity_ids of this CalledProcessDefinitionDtoAllOf.  # noqa: E501

        Ids of the CallActivities which call this process.  # noqa: E501

        :return: The called_from_activity_ids of this CalledProcessDefinitionDtoAllOf.  # noqa: E501
        :rtype: list[str]
        """
        return self._called_from_activity_ids

    @called_from_activity_ids.setter
    def called_from_activity_ids(self, called_from_activity_ids):
        """Sets the called_from_activity_ids of this CalledProcessDefinitionDtoAllOf.

        Ids of the CallActivities which call this process.  # noqa: E501

        :param called_from_activity_ids: The called_from_activity_ids of this CalledProcessDefinitionDtoAllOf.  # noqa: E501
        :type: list[str]
        """

        self._called_from_activity_ids = called_from_activity_ids

    @property
    def calling_process_definition_id(self):
        """Gets the calling_process_definition_id of this CalledProcessDefinitionDtoAllOf.  # noqa: E501

        The id of the calling process definition  # noqa: E501

        :return: The calling_process_definition_id of this CalledProcessDefinitionDtoAllOf.  # noqa: E501
        :rtype: str
        """
        return self._calling_process_definition_id

    @calling_process_definition_id.setter
    def calling_process_definition_id(self, calling_process_definition_id):
        """Sets the calling_process_definition_id of this CalledProcessDefinitionDtoAllOf.

        The id of the calling process definition  # noqa: E501

        :param calling_process_definition_id: The calling_process_definition_id of this CalledProcessDefinitionDtoAllOf.  # noqa: E501
        :type: str
        """

        self._calling_process_definition_id = calling_process_definition_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CalledProcessDefinitionDtoAllOf):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, CalledProcessDefinitionDtoAllOf):
            return True

        return self.to_dict() != other.to_dict()
