# coding: utf-8

"""
    Camunda Platform REST API

    OpenApi Spec for Camunda Platform REST API.  # noqa: E501

    The version of the OpenAPI document: 7.16.0
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from generic_camunda_client.configuration import Configuration


class CheckPasswordPolicyRuleDto(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'valid': 'bool',
        'placeholder': 'str',
        'parameter': 'dict(str, str)'
    }

    attribute_map = {
        'valid': 'valid',
        'placeholder': 'placeholder',
        'parameter': 'parameter'
    }

    def __init__(self, valid=None, placeholder=None, parameter=None, local_vars_configuration=None):  # noqa: E501
        """CheckPasswordPolicyRuleDto - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._valid = None
        self._placeholder = None
        self._parameter = None
        self.discriminator = None

        self.valid = valid
        self.placeholder = placeholder
        if parameter is not None:
            self.parameter = parameter

    @property
    def valid(self):
        """Gets the valid of this CheckPasswordPolicyRuleDto.  # noqa: E501

        `true` if the password is compliant with this rule, otherwise `false`.  # noqa: E501

        :return: The valid of this CheckPasswordPolicyRuleDto.  # noqa: E501
        :rtype: bool
        """
        return self._valid

    @valid.setter
    def valid(self, valid):
        """Sets the valid of this CheckPasswordPolicyRuleDto.

        `true` if the password is compliant with this rule, otherwise `false`.  # noqa: E501

        :param valid: The valid of this CheckPasswordPolicyRuleDto.  # noqa: E501
        :type: bool
        """

        self._valid = valid

    @property
    def placeholder(self):
        """Gets the placeholder of this CheckPasswordPolicyRuleDto.  # noqa: E501

        A placeholder string that contains the name of a password policy rule.  # noqa: E501

        :return: The placeholder of this CheckPasswordPolicyRuleDto.  # noqa: E501
        :rtype: str
        """
        return self._placeholder

    @placeholder.setter
    def placeholder(self, placeholder):
        """Sets the placeholder of this CheckPasswordPolicyRuleDto.

        A placeholder string that contains the name of a password policy rule.  # noqa: E501

        :param placeholder: The placeholder of this CheckPasswordPolicyRuleDto.  # noqa: E501
        :type: str
        """

        self._placeholder = placeholder

    @property
    def parameter(self):
        """Gets the parameter of this CheckPasswordPolicyRuleDto.  # noqa: E501

        A map that describes the characteristics of a password policy rule, such as the minimum number of digits.  # noqa: E501

        :return: The parameter of this CheckPasswordPolicyRuleDto.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._parameter

    @parameter.setter
    def parameter(self, parameter):
        """Sets the parameter of this CheckPasswordPolicyRuleDto.

        A map that describes the characteristics of a password policy rule, such as the minimum number of digits.  # noqa: E501

        :param parameter: The parameter of this CheckPasswordPolicyRuleDto.  # noqa: E501
        :type: dict(str, str)
        """

        self._parameter = parameter

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CheckPasswordPolicyRuleDto):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, CheckPasswordPolicyRuleDto):
            return True

        return self.to_dict() != other.to_dict()
