# coding: utf-8

"""
    Camunda Platform REST API

    OpenApi Spec for Camunda Platform REST API.  # noqa: E501

    The version of the OpenAPI document: 7.16.0
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from generic_camunda_client.configuration import Configuration


class CleanableHistoricBatchReportResultDto(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'batch_type': 'str',
        'history_time_to_live': 'int',
        'finished_batches_count': 'int',
        'cleanable_batches_count': 'int'
    }

    attribute_map = {
        'batch_type': 'batchType',
        'history_time_to_live': 'historyTimeToLive',
        'finished_batches_count': 'finishedBatchesCount',
        'cleanable_batches_count': 'cleanableBatchesCount'
    }

    def __init__(self, batch_type=None, history_time_to_live=None, finished_batches_count=None, cleanable_batches_count=None, local_vars_configuration=None):  # noqa: E501
        """CleanableHistoricBatchReportResultDto - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._batch_type = None
        self._history_time_to_live = None
        self._finished_batches_count = None
        self._cleanable_batches_count = None
        self.discriminator = None

        self.batch_type = batch_type
        self.history_time_to_live = history_time_to_live
        self.finished_batches_count = finished_batches_count
        self.cleanable_batches_count = cleanable_batches_count

    @property
    def batch_type(self):
        """Gets the batch_type of this CleanableHistoricBatchReportResultDto.  # noqa: E501

        The type of the batch operation.  # noqa: E501

        :return: The batch_type of this CleanableHistoricBatchReportResultDto.  # noqa: E501
        :rtype: str
        """
        return self._batch_type

    @batch_type.setter
    def batch_type(self, batch_type):
        """Sets the batch_type of this CleanableHistoricBatchReportResultDto.

        The type of the batch operation.  # noqa: E501

        :param batch_type: The batch_type of this CleanableHistoricBatchReportResultDto.  # noqa: E501
        :type: str
        """

        self._batch_type = batch_type

    @property
    def history_time_to_live(self):
        """Gets the history_time_to_live of this CleanableHistoricBatchReportResultDto.  # noqa: E501

        The history time to live of the batch operation.  # noqa: E501

        :return: The history_time_to_live of this CleanableHistoricBatchReportResultDto.  # noqa: E501
        :rtype: int
        """
        return self._history_time_to_live

    @history_time_to_live.setter
    def history_time_to_live(self, history_time_to_live):
        """Sets the history_time_to_live of this CleanableHistoricBatchReportResultDto.

        The history time to live of the batch operation.  # noqa: E501

        :param history_time_to_live: The history_time_to_live of this CleanableHistoricBatchReportResultDto.  # noqa: E501
        :type: int
        """

        self._history_time_to_live = history_time_to_live

    @property
    def finished_batches_count(self):
        """Gets the finished_batches_count of this CleanableHistoricBatchReportResultDto.  # noqa: E501

        The count of the finished batch operations.  # noqa: E501

        :return: The finished_batches_count of this CleanableHistoricBatchReportResultDto.  # noqa: E501
        :rtype: int
        """
        return self._finished_batches_count

    @finished_batches_count.setter
    def finished_batches_count(self, finished_batches_count):
        """Sets the finished_batches_count of this CleanableHistoricBatchReportResultDto.

        The count of the finished batch operations.  # noqa: E501

        :param finished_batches_count: The finished_batches_count of this CleanableHistoricBatchReportResultDto.  # noqa: E501
        :type: int
        """

        self._finished_batches_count = finished_batches_count

    @property
    def cleanable_batches_count(self):
        """Gets the cleanable_batches_count of this CleanableHistoricBatchReportResultDto.  # noqa: E501

        The count of the cleanable historic batch operations, referring to history time to live.  # noqa: E501

        :return: The cleanable_batches_count of this CleanableHistoricBatchReportResultDto.  # noqa: E501
        :rtype: int
        """
        return self._cleanable_batches_count

    @cleanable_batches_count.setter
    def cleanable_batches_count(self, cleanable_batches_count):
        """Sets the cleanable_batches_count of this CleanableHistoricBatchReportResultDto.

        The count of the cleanable historic batch operations, referring to history time to live.  # noqa: E501

        :param cleanable_batches_count: The cleanable_batches_count of this CleanableHistoricBatchReportResultDto.  # noqa: E501
        :type: int
        """

        self._cleanable_batches_count = cleanable_batches_count

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CleanableHistoricBatchReportResultDto):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, CleanableHistoricBatchReportResultDto):
            return True

        return self.to_dict() != other.to_dict()
