# coding: utf-8

"""
    Camunda Platform REST API

    OpenApi Spec for Camunda Platform REST API.  # noqa: E501

    The version of the OpenAPI document: 7.16.0
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from generic_camunda_client.configuration import Configuration


class ExecutionDto(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'id': 'str',
        'process_instance_id': 'str',
        'ended': 'bool',
        'tenant_id': 'str'
    }

    attribute_map = {
        'id': 'id',
        'process_instance_id': 'processInstanceId',
        'ended': 'ended',
        'tenant_id': 'tenantId'
    }

    def __init__(self, id=None, process_instance_id=None, ended=None, tenant_id=None, local_vars_configuration=None):  # noqa: E501
        """ExecutionDto - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._id = None
        self._process_instance_id = None
        self._ended = None
        self._tenant_id = None
        self.discriminator = None

        self.id = id
        self.process_instance_id = process_instance_id
        self.ended = ended
        self.tenant_id = tenant_id

    @property
    def id(self):
        """Gets the id of this ExecutionDto.  # noqa: E501

        The id of the Execution.  # noqa: E501

        :return: The id of this ExecutionDto.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this ExecutionDto.

        The id of the Execution.  # noqa: E501

        :param id: The id of this ExecutionDto.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def process_instance_id(self):
        """Gets the process_instance_id of this ExecutionDto.  # noqa: E501

        The id of the root of the execution tree representing the process instance.  # noqa: E501

        :return: The process_instance_id of this ExecutionDto.  # noqa: E501
        :rtype: str
        """
        return self._process_instance_id

    @process_instance_id.setter
    def process_instance_id(self, process_instance_id):
        """Sets the process_instance_id of this ExecutionDto.

        The id of the root of the execution tree representing the process instance.  # noqa: E501

        :param process_instance_id: The process_instance_id of this ExecutionDto.  # noqa: E501
        :type: str
        """

        self._process_instance_id = process_instance_id

    @property
    def ended(self):
        """Gets the ended of this ExecutionDto.  # noqa: E501

        Indicates if the execution is ended.  # noqa: E501

        :return: The ended of this ExecutionDto.  # noqa: E501
        :rtype: bool
        """
        return self._ended

    @ended.setter
    def ended(self, ended):
        """Sets the ended of this ExecutionDto.

        Indicates if the execution is ended.  # noqa: E501

        :param ended: The ended of this ExecutionDto.  # noqa: E501
        :type: bool
        """

        self._ended = ended

    @property
    def tenant_id(self):
        """Gets the tenant_id of this ExecutionDto.  # noqa: E501

        The id of the tenant this execution belongs to. Can be `null` if the execution belongs to no single tenant.  # noqa: E501

        :return: The tenant_id of this ExecutionDto.  # noqa: E501
        :rtype: str
        """
        return self._tenant_id

    @tenant_id.setter
    def tenant_id(self, tenant_id):
        """Sets the tenant_id of this ExecutionDto.

        The id of the tenant this execution belongs to. Can be `null` if the execution belongs to no single tenant.  # noqa: E501

        :param tenant_id: The tenant_id of this ExecutionDto.  # noqa: E501
        :type: str
        """

        self._tenant_id = tenant_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ExecutionDto):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ExecutionDto):
            return True

        return self.to_dict() != other.to_dict()
