# coding: utf-8

"""
    Camunda Platform REST API

    OpenApi Spec for Camunda Platform REST API.  # noqa: E501

    The version of the OpenAPI document: 7.16.0
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from generic_camunda_client.configuration import Configuration


class HistoricExternalTaskLogDto(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'id': 'str',
        'external_task_id': 'str',
        'timestamp': 'datetime',
        'topic_name': 'str',
        'worker_id': 'str',
        'retries': 'int',
        'priority': 'int',
        'error_message': 'str',
        'activity_id': 'str',
        'activity_instance_id': 'str',
        'execution_id': 'str',
        'process_instance_id': 'str',
        'process_definition_id': 'str',
        'process_definition_key': 'str',
        'tenant_id': 'str',
        'creation_log': 'bool',
        'failure_log': 'bool',
        'success_log': 'bool',
        'deletion_log': 'bool',
        'removal_time': 'datetime',
        'root_process_instance_id': 'str'
    }

    attribute_map = {
        'id': 'id',
        'external_task_id': 'externalTaskId',
        'timestamp': 'timestamp',
        'topic_name': 'topicName',
        'worker_id': 'workerId',
        'retries': 'retries',
        'priority': 'priority',
        'error_message': 'errorMessage',
        'activity_id': 'activityId',
        'activity_instance_id': 'activityInstanceId',
        'execution_id': 'executionId',
        'process_instance_id': 'processInstanceId',
        'process_definition_id': 'processDefinitionId',
        'process_definition_key': 'processDefinitionKey',
        'tenant_id': 'tenantId',
        'creation_log': 'creationLog',
        'failure_log': 'failureLog',
        'success_log': 'successLog',
        'deletion_log': 'deletionLog',
        'removal_time': 'removalTime',
        'root_process_instance_id': 'rootProcessInstanceId'
    }

    def __init__(self, id=None, external_task_id=None, timestamp=None, topic_name=None, worker_id=None, retries=None, priority=None, error_message=None, activity_id=None, activity_instance_id=None, execution_id=None, process_instance_id=None, process_definition_id=None, process_definition_key=None, tenant_id=None, creation_log=None, failure_log=None, success_log=None, deletion_log=None, removal_time=None, root_process_instance_id=None, local_vars_configuration=None):  # noqa: E501
        """HistoricExternalTaskLogDto - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._id = None
        self._external_task_id = None
        self._timestamp = None
        self._topic_name = None
        self._worker_id = None
        self._retries = None
        self._priority = None
        self._error_message = None
        self._activity_id = None
        self._activity_instance_id = None
        self._execution_id = None
        self._process_instance_id = None
        self._process_definition_id = None
        self._process_definition_key = None
        self._tenant_id = None
        self._creation_log = None
        self._failure_log = None
        self._success_log = None
        self._deletion_log = None
        self._removal_time = None
        self._root_process_instance_id = None
        self.discriminator = None

        self.id = id
        self.external_task_id = external_task_id
        self.timestamp = timestamp
        self.topic_name = topic_name
        self.worker_id = worker_id
        self.retries = retries
        self.priority = priority
        self.error_message = error_message
        self.activity_id = activity_id
        self.activity_instance_id = activity_instance_id
        self.execution_id = execution_id
        self.process_instance_id = process_instance_id
        self.process_definition_id = process_definition_id
        self.process_definition_key = process_definition_key
        self.tenant_id = tenant_id
        self.creation_log = creation_log
        self.failure_log = failure_log
        self.success_log = success_log
        self.deletion_log = deletion_log
        self.removal_time = removal_time
        self.root_process_instance_id = root_process_instance_id

    @property
    def id(self):
        """Gets the id of this HistoricExternalTaskLogDto.  # noqa: E501

        The id of the log entry.  # noqa: E501

        :return: The id of this HistoricExternalTaskLogDto.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this HistoricExternalTaskLogDto.

        The id of the log entry.  # noqa: E501

        :param id: The id of this HistoricExternalTaskLogDto.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def external_task_id(self):
        """Gets the external_task_id of this HistoricExternalTaskLogDto.  # noqa: E501

        The id of the external task.  # noqa: E501

        :return: The external_task_id of this HistoricExternalTaskLogDto.  # noqa: E501
        :rtype: str
        """
        return self._external_task_id

    @external_task_id.setter
    def external_task_id(self, external_task_id):
        """Sets the external_task_id of this HistoricExternalTaskLogDto.

        The id of the external task.  # noqa: E501

        :param external_task_id: The external_task_id of this HistoricExternalTaskLogDto.  # noqa: E501
        :type: str
        """

        self._external_task_id = external_task_id

    @property
    def timestamp(self):
        """Gets the timestamp of this HistoricExternalTaskLogDto.  # noqa: E501

        The time when the log entry has been written.  # noqa: E501

        :return: The timestamp of this HistoricExternalTaskLogDto.  # noqa: E501
        :rtype: datetime
        """
        return self._timestamp

    @timestamp.setter
    def timestamp(self, timestamp):
        """Sets the timestamp of this HistoricExternalTaskLogDto.

        The time when the log entry has been written.  # noqa: E501

        :param timestamp: The timestamp of this HistoricExternalTaskLogDto.  # noqa: E501
        :type: datetime
        """

        self._timestamp = timestamp

    @property
    def topic_name(self):
        """Gets the topic_name of this HistoricExternalTaskLogDto.  # noqa: E501

        The topic name of the associated external task.  # noqa: E501

        :return: The topic_name of this HistoricExternalTaskLogDto.  # noqa: E501
        :rtype: str
        """
        return self._topic_name

    @topic_name.setter
    def topic_name(self, topic_name):
        """Sets the topic_name of this HistoricExternalTaskLogDto.

        The topic name of the associated external task.  # noqa: E501

        :param topic_name: The topic_name of this HistoricExternalTaskLogDto.  # noqa: E501
        :type: str
        """

        self._topic_name = topic_name

    @property
    def worker_id(self):
        """Gets the worker_id of this HistoricExternalTaskLogDto.  # noqa: E501

        The id of the worker that posessed the most recent lock.  # noqa: E501

        :return: The worker_id of this HistoricExternalTaskLogDto.  # noqa: E501
        :rtype: str
        """
        return self._worker_id

    @worker_id.setter
    def worker_id(self, worker_id):
        """Sets the worker_id of this HistoricExternalTaskLogDto.

        The id of the worker that posessed the most recent lock.  # noqa: E501

        :param worker_id: The worker_id of this HistoricExternalTaskLogDto.  # noqa: E501
        :type: str
        """

        self._worker_id = worker_id

    @property
    def retries(self):
        """Gets the retries of this HistoricExternalTaskLogDto.  # noqa: E501

        The number of retries the associated external task has left.  # noqa: E501

        :return: The retries of this HistoricExternalTaskLogDto.  # noqa: E501
        :rtype: int
        """
        return self._retries

    @retries.setter
    def retries(self, retries):
        """Sets the retries of this HistoricExternalTaskLogDto.

        The number of retries the associated external task has left.  # noqa: E501

        :param retries: The retries of this HistoricExternalTaskLogDto.  # noqa: E501
        :type: int
        """

        self._retries = retries

    @property
    def priority(self):
        """Gets the priority of this HistoricExternalTaskLogDto.  # noqa: E501

        The execution priority the external task had when the log entry was created.  # noqa: E501

        :return: The priority of this HistoricExternalTaskLogDto.  # noqa: E501
        :rtype: int
        """
        return self._priority

    @priority.setter
    def priority(self, priority):
        """Sets the priority of this HistoricExternalTaskLogDto.

        The execution priority the external task had when the log entry was created.  # noqa: E501

        :param priority: The priority of this HistoricExternalTaskLogDto.  # noqa: E501
        :type: int
        """

        self._priority = priority

    @property
    def error_message(self):
        """Gets the error_message of this HistoricExternalTaskLogDto.  # noqa: E501

        The message of the error that occurred by executing the associated external task.  # noqa: E501

        :return: The error_message of this HistoricExternalTaskLogDto.  # noqa: E501
        :rtype: str
        """
        return self._error_message

    @error_message.setter
    def error_message(self, error_message):
        """Sets the error_message of this HistoricExternalTaskLogDto.

        The message of the error that occurred by executing the associated external task.  # noqa: E501

        :param error_message: The error_message of this HistoricExternalTaskLogDto.  # noqa: E501
        :type: str
        """

        self._error_message = error_message

    @property
    def activity_id(self):
        """Gets the activity_id of this HistoricExternalTaskLogDto.  # noqa: E501

        The id of the activity on which the associated external task was created.  # noqa: E501

        :return: The activity_id of this HistoricExternalTaskLogDto.  # noqa: E501
        :rtype: str
        """
        return self._activity_id

    @activity_id.setter
    def activity_id(self, activity_id):
        """Sets the activity_id of this HistoricExternalTaskLogDto.

        The id of the activity on which the associated external task was created.  # noqa: E501

        :param activity_id: The activity_id of this HistoricExternalTaskLogDto.  # noqa: E501
        :type: str
        """

        self._activity_id = activity_id

    @property
    def activity_instance_id(self):
        """Gets the activity_instance_id of this HistoricExternalTaskLogDto.  # noqa: E501

        The id of the activity instance on which the associated external task was created.  # noqa: E501

        :return: The activity_instance_id of this HistoricExternalTaskLogDto.  # noqa: E501
        :rtype: str
        """
        return self._activity_instance_id

    @activity_instance_id.setter
    def activity_instance_id(self, activity_instance_id):
        """Sets the activity_instance_id of this HistoricExternalTaskLogDto.

        The id of the activity instance on which the associated external task was created.  # noqa: E501

        :param activity_instance_id: The activity_instance_id of this HistoricExternalTaskLogDto.  # noqa: E501
        :type: str
        """

        self._activity_instance_id = activity_instance_id

    @property
    def execution_id(self):
        """Gets the execution_id of this HistoricExternalTaskLogDto.  # noqa: E501

        The execution id on which the associated external task was created.  # noqa: E501

        :return: The execution_id of this HistoricExternalTaskLogDto.  # noqa: E501
        :rtype: str
        """
        return self._execution_id

    @execution_id.setter
    def execution_id(self, execution_id):
        """Sets the execution_id of this HistoricExternalTaskLogDto.

        The execution id on which the associated external task was created.  # noqa: E501

        :param execution_id: The execution_id of this HistoricExternalTaskLogDto.  # noqa: E501
        :type: str
        """

        self._execution_id = execution_id

    @property
    def process_instance_id(self):
        """Gets the process_instance_id of this HistoricExternalTaskLogDto.  # noqa: E501

        The id of the process instance on which the associated external task was created.  # noqa: E501

        :return: The process_instance_id of this HistoricExternalTaskLogDto.  # noqa: E501
        :rtype: str
        """
        return self._process_instance_id

    @process_instance_id.setter
    def process_instance_id(self, process_instance_id):
        """Sets the process_instance_id of this HistoricExternalTaskLogDto.

        The id of the process instance on which the associated external task was created.  # noqa: E501

        :param process_instance_id: The process_instance_id of this HistoricExternalTaskLogDto.  # noqa: E501
        :type: str
        """

        self._process_instance_id = process_instance_id

    @property
    def process_definition_id(self):
        """Gets the process_definition_id of this HistoricExternalTaskLogDto.  # noqa: E501

        The id of the process definition which the associated external task belongs to.  # noqa: E501

        :return: The process_definition_id of this HistoricExternalTaskLogDto.  # noqa: E501
        :rtype: str
        """
        return self._process_definition_id

    @process_definition_id.setter
    def process_definition_id(self, process_definition_id):
        """Sets the process_definition_id of this HistoricExternalTaskLogDto.

        The id of the process definition which the associated external task belongs to.  # noqa: E501

        :param process_definition_id: The process_definition_id of this HistoricExternalTaskLogDto.  # noqa: E501
        :type: str
        """

        self._process_definition_id = process_definition_id

    @property
    def process_definition_key(self):
        """Gets the process_definition_key of this HistoricExternalTaskLogDto.  # noqa: E501

        The key of the process definition which the associated external task belongs to.  # noqa: E501

        :return: The process_definition_key of this HistoricExternalTaskLogDto.  # noqa: E501
        :rtype: str
        """
        return self._process_definition_key

    @process_definition_key.setter
    def process_definition_key(self, process_definition_key):
        """Sets the process_definition_key of this HistoricExternalTaskLogDto.

        The key of the process definition which the associated external task belongs to.  # noqa: E501

        :param process_definition_key: The process_definition_key of this HistoricExternalTaskLogDto.  # noqa: E501
        :type: str
        """

        self._process_definition_key = process_definition_key

    @property
    def tenant_id(self):
        """Gets the tenant_id of this HistoricExternalTaskLogDto.  # noqa: E501

        The id of the tenant that this historic external task log entry belongs to.  # noqa: E501

        :return: The tenant_id of this HistoricExternalTaskLogDto.  # noqa: E501
        :rtype: str
        """
        return self._tenant_id

    @tenant_id.setter
    def tenant_id(self, tenant_id):
        """Sets the tenant_id of this HistoricExternalTaskLogDto.

        The id of the tenant that this historic external task log entry belongs to.  # noqa: E501

        :param tenant_id: The tenant_id of this HistoricExternalTaskLogDto.  # noqa: E501
        :type: str
        """

        self._tenant_id = tenant_id

    @property
    def creation_log(self):
        """Gets the creation_log of this HistoricExternalTaskLogDto.  # noqa: E501

        A flag indicating whether this log represents the creation of the associated external task.  # noqa: E501

        :return: The creation_log of this HistoricExternalTaskLogDto.  # noqa: E501
        :rtype: bool
        """
        return self._creation_log

    @creation_log.setter
    def creation_log(self, creation_log):
        """Sets the creation_log of this HistoricExternalTaskLogDto.

        A flag indicating whether this log represents the creation of the associated external task.  # noqa: E501

        :param creation_log: The creation_log of this HistoricExternalTaskLogDto.  # noqa: E501
        :type: bool
        """

        self._creation_log = creation_log

    @property
    def failure_log(self):
        """Gets the failure_log of this HistoricExternalTaskLogDto.  # noqa: E501

        A flag indicating whether this log represents the failed execution of the associated external task.  # noqa: E501

        :return: The failure_log of this HistoricExternalTaskLogDto.  # noqa: E501
        :rtype: bool
        """
        return self._failure_log

    @failure_log.setter
    def failure_log(self, failure_log):
        """Sets the failure_log of this HistoricExternalTaskLogDto.

        A flag indicating whether this log represents the failed execution of the associated external task.  # noqa: E501

        :param failure_log: The failure_log of this HistoricExternalTaskLogDto.  # noqa: E501
        :type: bool
        """

        self._failure_log = failure_log

    @property
    def success_log(self):
        """Gets the success_log of this HistoricExternalTaskLogDto.  # noqa: E501

        A flag indicating whether this log represents the successful execution of the associated external task.  # noqa: E501

        :return: The success_log of this HistoricExternalTaskLogDto.  # noqa: E501
        :rtype: bool
        """
        return self._success_log

    @success_log.setter
    def success_log(self, success_log):
        """Sets the success_log of this HistoricExternalTaskLogDto.

        A flag indicating whether this log represents the successful execution of the associated external task.  # noqa: E501

        :param success_log: The success_log of this HistoricExternalTaskLogDto.  # noqa: E501
        :type: bool
        """

        self._success_log = success_log

    @property
    def deletion_log(self):
        """Gets the deletion_log of this HistoricExternalTaskLogDto.  # noqa: E501

        A flag indicating whether this log represents the deletion of the associated external task.  # noqa: E501

        :return: The deletion_log of this HistoricExternalTaskLogDto.  # noqa: E501
        :rtype: bool
        """
        return self._deletion_log

    @deletion_log.setter
    def deletion_log(self, deletion_log):
        """Sets the deletion_log of this HistoricExternalTaskLogDto.

        A flag indicating whether this log represents the deletion of the associated external task.  # noqa: E501

        :param deletion_log: The deletion_log of this HistoricExternalTaskLogDto.  # noqa: E501
        :type: bool
        """

        self._deletion_log = deletion_log

    @property
    def removal_time(self):
        """Gets the removal_time of this HistoricExternalTaskLogDto.  # noqa: E501

        The time after which this log should be removed by the History Cleanup job. Default format `yyyy-MM-dd'T'HH:mm:ss.SSSZ`.  For further information, please see the [documentation](https://docs.camunda.org/manual/7.16/reference/rest/overview/date-format/)  # noqa: E501

        :return: The removal_time of this HistoricExternalTaskLogDto.  # noqa: E501
        :rtype: datetime
        """
        return self._removal_time

    @removal_time.setter
    def removal_time(self, removal_time):
        """Sets the removal_time of this HistoricExternalTaskLogDto.

        The time after which this log should be removed by the History Cleanup job. Default format `yyyy-MM-dd'T'HH:mm:ss.SSSZ`.  For further information, please see the [documentation](https://docs.camunda.org/manual/7.16/reference/rest/overview/date-format/)  # noqa: E501

        :param removal_time: The removal_time of this HistoricExternalTaskLogDto.  # noqa: E501
        :type: datetime
        """

        self._removal_time = removal_time

    @property
    def root_process_instance_id(self):
        """Gets the root_process_instance_id of this HistoricExternalTaskLogDto.  # noqa: E501

        The process instance id of the root process instance that initiated the process containing this log.  # noqa: E501

        :return: The root_process_instance_id of this HistoricExternalTaskLogDto.  # noqa: E501
        :rtype: str
        """
        return self._root_process_instance_id

    @root_process_instance_id.setter
    def root_process_instance_id(self, root_process_instance_id):
        """Sets the root_process_instance_id of this HistoricExternalTaskLogDto.

        The process instance id of the root process instance that initiated the process containing this log.  # noqa: E501

        :param root_process_instance_id: The root_process_instance_id of this HistoricExternalTaskLogDto.  # noqa: E501
        :type: str
        """

        self._root_process_instance_id = root_process_instance_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, HistoricExternalTaskLogDto):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, HistoricExternalTaskLogDto):
            return True

        return self.to_dict() != other.to_dict()
