# coding: utf-8

"""
    Camunda Platform REST API

    OpenApi Spec for Camunda Platform REST API.  # noqa: E501

    The version of the OpenAPI document: 7.16.0
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from generic_camunda_client.configuration import Configuration


class JobDefinitionPriorityDto(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'priority': 'int',
        'include_jobs': 'bool'
    }

    attribute_map = {
        'priority': 'priority',
        'include_jobs': 'includeJobs'
    }

    def __init__(self, priority=None, include_jobs=None, local_vars_configuration=None):  # noqa: E501
        """JobDefinitionPriorityDto - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._priority = None
        self._include_jobs = None
        self.discriminator = None

        self.priority = priority
        self.include_jobs = include_jobs

    @property
    def priority(self):
        """Gets the priority of this JobDefinitionPriorityDto.  # noqa: E501

        The new execution priority number for jobs of the given definition. The definition's priority can be reset by using the value `null`. In that case, the job definition's priority no longer applies but a new job's priority is determined as specified in the process model.  # noqa: E501

        :return: The priority of this JobDefinitionPriorityDto.  # noqa: E501
        :rtype: int
        """
        return self._priority

    @priority.setter
    def priority(self, priority):
        """Sets the priority of this JobDefinitionPriorityDto.

        The new execution priority number for jobs of the given definition. The definition's priority can be reset by using the value `null`. In that case, the job definition's priority no longer applies but a new job's priority is determined as specified in the process model.  # noqa: E501

        :param priority: The priority of this JobDefinitionPriorityDto.  # noqa: E501
        :type: int
        """

        self._priority = priority

    @property
    def include_jobs(self):
        """Gets the include_jobs of this JobDefinitionPriorityDto.  # noqa: E501

        A boolean value indicating whether existing jobs of the given definition should receive the priority as well. Default value is `false`. Can only be `true` when the __priority__ parameter is not `null`.  # noqa: E501

        :return: The include_jobs of this JobDefinitionPriorityDto.  # noqa: E501
        :rtype: bool
        """
        return self._include_jobs

    @include_jobs.setter
    def include_jobs(self, include_jobs):
        """Sets the include_jobs of this JobDefinitionPriorityDto.

        A boolean value indicating whether existing jobs of the given definition should receive the priority as well. Default value is `false`. Can only be `true` when the __priority__ parameter is not `null`.  # noqa: E501

        :param include_jobs: The include_jobs of this JobDefinitionPriorityDto.  # noqa: E501
        :type: bool
        """

        self._include_jobs = include_jobs

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, JobDefinitionPriorityDto):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, JobDefinitionPriorityDto):
            return True

        return self.to_dict() != other.to_dict()
