# coding: utf-8

"""
    Camunda Platform REST API

    OpenApi Spec for Camunda Platform REST API.  # noqa: E501

    The version of the OpenAPI document: 7.16.0
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from generic_camunda_client.configuration import Configuration


class MissingAuthorizationDto(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'permission_name': 'str',
        'resource_name': 'str',
        'resource_id': 'str'
    }

    attribute_map = {
        'permission_name': 'permissionName',
        'resource_name': 'resourceName',
        'resource_id': 'resourceId'
    }

    def __init__(self, permission_name=None, resource_name=None, resource_id=None, local_vars_configuration=None):  # noqa: E501
        """MissingAuthorizationDto - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._permission_name = None
        self._resource_name = None
        self._resource_id = None
        self.discriminator = None

        self.permission_name = permission_name
        self.resource_name = resource_name
        self.resource_id = resource_id

    @property
    def permission_name(self):
        """Gets the permission_name of this MissingAuthorizationDto.  # noqa: E501

        The permission name that the user is missing.  # noqa: E501

        :return: The permission_name of this MissingAuthorizationDto.  # noqa: E501
        :rtype: str
        """
        return self._permission_name

    @permission_name.setter
    def permission_name(self, permission_name):
        """Sets the permission_name of this MissingAuthorizationDto.

        The permission name that the user is missing.  # noqa: E501

        :param permission_name: The permission_name of this MissingAuthorizationDto.  # noqa: E501
        :type: str
        """

        self._permission_name = permission_name

    @property
    def resource_name(self):
        """Gets the resource_name of this MissingAuthorizationDto.  # noqa: E501

        The name of the resource that the user is missing permission for.  # noqa: E501

        :return: The resource_name of this MissingAuthorizationDto.  # noqa: E501
        :rtype: str
        """
        return self._resource_name

    @resource_name.setter
    def resource_name(self, resource_name):
        """Sets the resource_name of this MissingAuthorizationDto.

        The name of the resource that the user is missing permission for.  # noqa: E501

        :param resource_name: The resource_name of this MissingAuthorizationDto.  # noqa: E501
        :type: str
        """

        self._resource_name = resource_name

    @property
    def resource_id(self):
        """Gets the resource_id of this MissingAuthorizationDto.  # noqa: E501

        The id of the resource that the user is missing permission for.  # noqa: E501

        :return: The resource_id of this MissingAuthorizationDto.  # noqa: E501
        :rtype: str
        """
        return self._resource_id

    @resource_id.setter
    def resource_id(self, resource_id):
        """Sets the resource_id of this MissingAuthorizationDto.

        The id of the resource that the user is missing permission for.  # noqa: E501

        :param resource_id: The resource_id of this MissingAuthorizationDto.  # noqa: E501
        :type: str
        """

        self._resource_id = resource_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, MissingAuthorizationDto):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, MissingAuthorizationDto):
            return True

        return self.to_dict() != other.to_dict()
