# coding: utf-8

"""
    Camunda Platform REST API

    OpenApi Spec for Camunda Platform REST API.  # noqa: E501

    The version of the OpenAPI document: 7.16.0
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from generic_camunda_client.configuration import Configuration


class PatchVariablesDto(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'modifications': 'dict(str, VariableValueDto)',
        'deletions': 'list[str]'
    }

    attribute_map = {
        'modifications': 'modifications',
        'deletions': 'deletions'
    }

    def __init__(self, modifications=None, deletions=None, local_vars_configuration=None):  # noqa: E501
        """PatchVariablesDto - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._modifications = None
        self._deletions = None
        self.discriminator = None

        self.modifications = modifications
        self.deletions = deletions

    @property
    def modifications(self):
        """Gets the modifications of this PatchVariablesDto.  # noqa: E501

        A JSON object containing variable key-value pairs.  # noqa: E501

        :return: The modifications of this PatchVariablesDto.  # noqa: E501
        :rtype: dict(str, VariableValueDto)
        """
        return self._modifications

    @modifications.setter
    def modifications(self, modifications):
        """Sets the modifications of this PatchVariablesDto.

        A JSON object containing variable key-value pairs.  # noqa: E501

        :param modifications: The modifications of this PatchVariablesDto.  # noqa: E501
        :type: dict(str, VariableValueDto)
        """

        self._modifications = modifications

    @property
    def deletions(self):
        """Gets the deletions of this PatchVariablesDto.  # noqa: E501

        An array of String keys of variables to be deleted.  # noqa: E501

        :return: The deletions of this PatchVariablesDto.  # noqa: E501
        :rtype: list[str]
        """
        return self._deletions

    @deletions.setter
    def deletions(self, deletions):
        """Sets the deletions of this PatchVariablesDto.

        An array of String keys of variables to be deleted.  # noqa: E501

        :param deletions: The deletions of this PatchVariablesDto.  # noqa: E501
        :type: list[str]
        """

        self._deletions = deletions

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PatchVariablesDto):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, PatchVariablesDto):
            return True

        return self.to_dict() != other.to_dict()
