# coding: utf-8

"""
    Camunda Platform REST API

    OpenApi Spec for Camunda Platform REST API.  # noqa: E501

    The version of the OpenAPI document: 7.16.0
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from generic_camunda_client.configuration import Configuration


class RedeploymentDto(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'resource_ids': 'list[str]',
        'resource_names': 'list[str]',
        'source': 'str'
    }

    attribute_map = {
        'resource_ids': 'resourceIds',
        'resource_names': 'resourceNames',
        'source': 'source'
    }

    def __init__(self, resource_ids=None, resource_names=None, source=None, local_vars_configuration=None):  # noqa: E501
        """RedeploymentDto - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._resource_ids = None
        self._resource_names = None
        self._source = None
        self.discriminator = None

        self.resource_ids = resource_ids
        self.resource_names = resource_names
        self.source = source

    @property
    def resource_ids(self):
        """Gets the resource_ids of this RedeploymentDto.  # noqa: E501

        A list of deployment resource ids to re-deploy.  # noqa: E501

        :return: The resource_ids of this RedeploymentDto.  # noqa: E501
        :rtype: list[str]
        """
        return self._resource_ids

    @resource_ids.setter
    def resource_ids(self, resource_ids):
        """Sets the resource_ids of this RedeploymentDto.

        A list of deployment resource ids to re-deploy.  # noqa: E501

        :param resource_ids: The resource_ids of this RedeploymentDto.  # noqa: E501
        :type: list[str]
        """

        self._resource_ids = resource_ids

    @property
    def resource_names(self):
        """Gets the resource_names of this RedeploymentDto.  # noqa: E501

        A list of deployment resource names to re-deploy.  # noqa: E501

        :return: The resource_names of this RedeploymentDto.  # noqa: E501
        :rtype: list[str]
        """
        return self._resource_names

    @resource_names.setter
    def resource_names(self, resource_names):
        """Sets the resource_names of this RedeploymentDto.

        A list of deployment resource names to re-deploy.  # noqa: E501

        :param resource_names: The resource_names of this RedeploymentDto.  # noqa: E501
        :type: list[str]
        """

        self._resource_names = resource_names

    @property
    def source(self):
        """Gets the source of this RedeploymentDto.  # noqa: E501

        Sets the source of the deployment.  # noqa: E501

        :return: The source of this RedeploymentDto.  # noqa: E501
        :rtype: str
        """
        return self._source

    @source.setter
    def source(self, source):
        """Sets the source of this RedeploymentDto.

        Sets the source of the deployment.  # noqa: E501

        :param source: The source of this RedeploymentDto.  # noqa: E501
        :type: str
        """

        self._source = source

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, RedeploymentDto):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, RedeploymentDto):
            return True

        return self.to_dict() != other.to_dict()
