# coding: utf-8

"""
    Camunda Platform REST API

    OpenApi Spec for Camunda Platform REST API.  # noqa: E501

    The version of the OpenAPI document: 7.16.0
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from generic_camunda_client.configuration import Configuration


class SetRemovalTimeToHistoricDecisionInstancesDtoAllOf(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'hierarchical': 'bool',
        'historic_decision_instance_query': 'HistoricDecisionInstanceQueryDto',
        'historic_decision_instance_ids': 'list[str]'
    }

    attribute_map = {
        'hierarchical': 'hierarchical',
        'historic_decision_instance_query': 'historicDecisionInstanceQuery',
        'historic_decision_instance_ids': 'historicDecisionInstanceIds'
    }

    def __init__(self, hierarchical=None, historic_decision_instance_query=None, historic_decision_instance_ids=None, local_vars_configuration=None):  # noqa: E501
        """SetRemovalTimeToHistoricDecisionInstancesDtoAllOf - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._hierarchical = None
        self._historic_decision_instance_query = None
        self._historic_decision_instance_ids = None
        self.discriminator = None

        self.hierarchical = hierarchical
        if historic_decision_instance_query is not None:
            self.historic_decision_instance_query = historic_decision_instance_query
        self.historic_decision_instance_ids = historic_decision_instance_ids

    @property
    def hierarchical(self):
        """Gets the hierarchical of this SetRemovalTimeToHistoricDecisionInstancesDtoAllOf.  # noqa: E501

        Sets the removal time to all historic decision instances in the hierarchy. Value may only be `true`, as `false` is the default behavior.  # noqa: E501

        :return: The hierarchical of this SetRemovalTimeToHistoricDecisionInstancesDtoAllOf.  # noqa: E501
        :rtype: bool
        """
        return self._hierarchical

    @hierarchical.setter
    def hierarchical(self, hierarchical):
        """Sets the hierarchical of this SetRemovalTimeToHistoricDecisionInstancesDtoAllOf.

        Sets the removal time to all historic decision instances in the hierarchy. Value may only be `true`, as `false` is the default behavior.  # noqa: E501

        :param hierarchical: The hierarchical of this SetRemovalTimeToHistoricDecisionInstancesDtoAllOf.  # noqa: E501
        :type: bool
        """

        self._hierarchical = hierarchical

    @property
    def historic_decision_instance_query(self):
        """Gets the historic_decision_instance_query of this SetRemovalTimeToHistoricDecisionInstancesDtoAllOf.  # noqa: E501


        :return: The historic_decision_instance_query of this SetRemovalTimeToHistoricDecisionInstancesDtoAllOf.  # noqa: E501
        :rtype: HistoricDecisionInstanceQueryDto
        """
        return self._historic_decision_instance_query

    @historic_decision_instance_query.setter
    def historic_decision_instance_query(self, historic_decision_instance_query):
        """Sets the historic_decision_instance_query of this SetRemovalTimeToHistoricDecisionInstancesDtoAllOf.


        :param historic_decision_instance_query: The historic_decision_instance_query of this SetRemovalTimeToHistoricDecisionInstancesDtoAllOf.  # noqa: E501
        :type: HistoricDecisionInstanceQueryDto
        """

        self._historic_decision_instance_query = historic_decision_instance_query

    @property
    def historic_decision_instance_ids(self):
        """Gets the historic_decision_instance_ids of this SetRemovalTimeToHistoricDecisionInstancesDtoAllOf.  # noqa: E501

        The ids of the historic decision instances to set the removal time for.  # noqa: E501

        :return: The historic_decision_instance_ids of this SetRemovalTimeToHistoricDecisionInstancesDtoAllOf.  # noqa: E501
        :rtype: list[str]
        """
        return self._historic_decision_instance_ids

    @historic_decision_instance_ids.setter
    def historic_decision_instance_ids(self, historic_decision_instance_ids):
        """Sets the historic_decision_instance_ids of this SetRemovalTimeToHistoricDecisionInstancesDtoAllOf.

        The ids of the historic decision instances to set the removal time for.  # noqa: E501

        :param historic_decision_instance_ids: The historic_decision_instance_ids of this SetRemovalTimeToHistoricDecisionInstancesDtoAllOf.  # noqa: E501
        :type: list[str]
        """

        self._historic_decision_instance_ids = historic_decision_instance_ids

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SetRemovalTimeToHistoricDecisionInstancesDtoAllOf):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, SetRemovalTimeToHistoricDecisionInstancesDtoAllOf):
            return True

        return self.to_dict() != other.to_dict()
